'use strict'
const co = require('co');
const exec = require('child_process').exec
const prompt = require('co-prompt');
const config = require('../templates');
const chalk = require('chalk');
const fs = require('fs-extra');

const getPrejectByUrL = (tplName) => {
  const gitUrl = config.tpl[tplName].urlOrPath;
  const projectName = tplName;
  const branch = config.tpl[tplName].branch;
  let cmdStr = `cd ${__dirname}/../templates && mkdir ${projectName} && git clone ${gitUrl} ${projectName} && cd ${projectName} && git checkout ${branch}`

  console.log(chalk.white('\n 开始下载...'));

  exec(cmdStr, (error, stdout, stderr) => {
    if (error) {
      console.log(error)
      process.exit()
    }
    console.log(chalk.green('\n √ 完成!'));
    process.exit();
  });
}

const isUrl = (tplName) => {
  const self = this;
  fs.writeJson(__dirname + '/../templates.json', config, function(err) {
    if (err) console.log(err)
    getPrejectByUrL(tplName);
  });
}

const isPath = (tplName) => {
  console.log(chalk.white('\n 开始复制...'));
  const orginPath = config.tpl[tplName].urlOrPath;
  fs.writeJson(__dirname + '/../templates.json', config, function(err) {
    if (err) console.log(err);
    fs.copy(orginPath, __dirname + '/../templates/' + tplName, function(err) {
      if (err) return console.error(err);
      console.log(chalk.green('\n √ 完成!'));
      process.exit();
    });
  })
}

module.exports = () => {
  co(function*() {
    let branch;
    let tplName = yield prompt('模板名称: ')
    let urlOrPath = yield prompt('Git地址或者本地路径（绝对路径）: ')

    if (urlOrPath.indexOf("http") !== -1) {
      branch = yield prompt('分支: ')
    }

    if (!config.tpl[tplName]) {
      config.tpl[tplName] = {};
      config.tpl[tplName]['urlOrPath'] = urlOrPath.replace(/[\u0000-\u0019]/g, '');
      if (branch) {
        config.tpl[tplName]['branch'] = branch;
        isUrl(tplName);
      } else {
        isPath(tplName);
      }
    } else {
      console.log(chalk.red('模板名称已经存在!'))
      process.exit()
    }
  })
}